
#include <crtdbg.h>
#include "OrgWindow.h"

#include <windows.h>
#include <list>
#include <map>

using namespace std;

namespace OrgWinGUI{

	////////////////----------------------------------------////////////////
	////////////////										////////////////
	////////////////		EBhEiNX			////////////////
	////////////////										////////////////
	////////////////----------------------------------------////////////////

	//
	//	EBhEi"^CCe[u"NX
	//
	const double OWP_Timeline::LineData::TIME_ERROR_WIDTH= 0.0001;

	////////////////----------------------------------------////////////////
	////////////////										////////////////
	////////////////		IWiEBhENX		////////////////
	////////////////										////////////////
	////////////////----------------------------------------////////////////

	////////////////////////// MemberVar /////////////////////////////

	//	MemberVar : EBhEnhOrgWindowCX^X|C^̑Ή}bv
	map<HWND,OrgWindow*> OrgWindow::hWndAndClassMap;

	//////////////////////////// Method //////////////////////////////

	//
	//	Method : EBhEvV[W
	//
	LRESULT CALLBACK OrgWindow::wndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam){
		map<HWND,OrgWindow*>::iterator owItr;
		owItr= hWndAndClassMap.find(hwnd);
		if( owItr==hWndAndClassMap.end() ){
			return (DefWindowProc(hwnd,message,wParam,lParam));
		}
		OrgWindow *owner= owItr->second;	//EBhE쐬̃NX̃CX^X|C^


		MouseEvent mouseEvent;
		KeyboardEvent keyboardEvent;
		switch (message){				//Cxg쐬
			case WM_LBUTTONDOWN:
			case WM_RBUTTONDOWN:
			case WM_MBUTTONDOWN:
			case WM_LBUTTONUP:
			case WM_RBUTTONUP:
			case WM_MBUTTONUP:
			case WM_MOUSEMOVE:
				POINT tmpPoint;
				GetCursorPos(&tmpPoint);

				mouseEvent.globalX= (int)tmpPoint.x;
				mouseEvent.globalY= (int)tmpPoint.y;
				mouseEvent.localX= mouseEvent.globalX- owner->pos.x;
				mouseEvent.localY= mouseEvent.globalY- owner->pos.y;
				mouseEvent.shiftKey= GetKeyState(VK_SHIFT)<0;
				mouseEvent.ctrlKey= GetKeyState(VK_CONTROL)<0;
				mouseEvent.altKey= GetKeyState(VK_MENU)<0;
				break;
			case WM_KEYDOWN:
			case WM_KEYUP:
				keyboardEvent.keyCode= (int)(unsigned int)wParam;
				keyboardEvent.shiftKey= GetKeyState(VK_SHIFT)<0;
				keyboardEvent.ctrlKey= GetKeyState(VK_CONTROL)<0;
				keyboardEvent.altKey= GetKeyState(VK_MENU)<0;
				keyboardEvent.repeat= (lParam&0x40000000)!=0;
				if( message==WM_KEYUP ){
					keyboardEvent.repeat=false;
					keyboardEvent.onDown=false;
				}else{
					keyboardEvent.onDown=true;
				}
				break;
		}

		switch (message){
			case WM_LBUTTONDOWN:		//}EX{^_E
				owner->onLButtonDown(mouseEvent);
				return 0;
			case WM_LBUTTONUP:			//}EX{^Abv
				owner->onLButtonUp(mouseEvent);
				return 0;
			case WM_RBUTTONDOWN:		//E}EX{^_E
				owner->onRButtonDown(mouseEvent);
				return 0;
			case WM_RBUTTONUP:			//E}EX{^Abv
				owner->onRButtonUp(mouseEvent);
				return 0;
			case WM_MOUSEMOVE:			//}EXړ
				owner->onMouseMove(mouseEvent);
				return 0;
			case WM_KEYDOWN:			//L[{[hCxg
			case WM_KEYUP:
				owner->onKeyboard(keyboardEvent);
				return 0;
			case WM_MOVE:				//ʒuύX
				owner->refreshPosAndSize();
				return 0;
			case WM_SIZE:				//TCYύX
				owner->refreshPosAndSize();
				owner->callRewrite();
				owner->nowChangingSize= true;
				return 0;
			case WM_PAINT:				//`
				owner->allPaint();
				return 0;
			case WM_CLOSE:
				DestroyWindow(hwnd);
				return 0;
			case WM_DESTROY:
				PostQuitMessage(0);
				return 0;
			default:
				if( owner->nowChangingSize ){
					owner->nowChangingSize= false;
					owner->reAddAllParts();
				}
				return (DefWindowProc(hwnd,message,wParam,lParam));
		}

		return 0;
	}

}