#ifndef QUBFILEH
#define QUBFILEH

#include <d3dx9.h>
#include <coef.h>
#include <XMLIO.h>


class CModel;
class CBone;
class CMotionPoint;
class CQuaternion;

class CQubFile : public CXMLIO
{
public:
	CQubFile();
	virtual ~CQubFile();

	int WriteQubFile( WCHAR* strpath, MOTINFO* srcmotinfo, CBone* srctopbone, int srcbonenum );
	int LoadQubFile( WCHAR* strpath, CModel* srcmodel, int* newid );

private:
	virtual int InitParams();
	virtual int DestroyObjs();

	int WriteFileInfo();
	void WriteBoneReq( CBone* srcbone, int broflag );

	int CheckFileVersion( XMLIOBUF* xmliobuf );
	int ReadMotionInfo( WCHAR* wfilename, XMLIOBUF* xmliobuf );
	int ReadBone( XMLIOBUF* xmliobuf );
	int ReadMotionPoint( XMLIOBUF* xmliobuf, CBone* srcbone );

public:
	CModel* m_model;
	CBone* m_topbone;
	int m_bonenum;
	int m_motid;
	MOTINFO* m_motinfo;
};

#endif